// Datei: EEPROM.C
//
// Lesen und schreiben des Daten EEPROM im PIC
//
// Holger Klabunde
// 29.04.2001
// Compiler PICC Lite

#include "prozess.h"      /* Der verwendete Prozessor */

//Daten EEPROM Adresse 'addr' lesen
unsigned char Read_EEProm(unsigned char addr)
{
  EEADR = addr;     // Adresse in Register eintragen
  RD = 1;  // Do a 'read'
  return(EEDATA);   // Wert zurckgeben
}

//Schreibt ein Byte ins EEPROM
void Write_EEProm(unsigned char addr, unsigned char data)
{
  WREN = 1;  // Schreiben ermglichen

  EEDATA = data;    // Data in data register
  EEADR = addr;     // Write to addres

  RP0 = 1;   // Set page 1 to access EECON1, EECON2
  GIE=0;     // Disable interrupts

#asm
  MOVLW  55H        // Writing 0x55 must be followed
  MOVWF  09         // immediately by writing 0xAA
  MOVLW  0AAh       // to EECON2
  MOVWF  09
  BSF    08,1       // EECON1.WR=1 d.h. schreiben des EEPROM starten
#endasm

  GIE = 1;   // Enable interrupts
  EEIE=1; 	//Interrupt bei EEPROM Write Complete
//Jetzt entweder lnger warten und Verify
//oder EEPROM-Interrupt + SLEEP + Verify
  RP0 = 0;
  SLEEP();
}
